#include "framecpp/Common/Description.hh"
#include "framecpp/Common/TOCInfo.hh"

#include "framecpp/Version4/FrameSpec.hh"
#include "framecpp/Version4/FrTOCSummary.hh"
#include "framecpp/Version4/FrSE.hh"
#include "framecpp/Version4/FrSH.hh"
#include "framecpp/Version4/FrTOC.hh"

#include "framecpp/Version4/STRING.hh"

using FrameCPP::Common::Description;
using FrameCPP::Common::FrameSpec;
using FrameCPP::Common::TOCInfo;

namespace FrameCPP
{
  namespace Version_4
  {
    //===================================================================
    //===================================================================
    void FrTOCSummary::
    Description( Common::Description& Desc )
    {
      Desc( FrSE( "nSummary", "INT_4U",
		  "Number of unique FrSummary names in file." ) );
      Desc( FrSE( "nameSum", "*STRING", "Array of FrSummary names" ) );
      Desc( FrSE( "positionSum", "*INT_8U",
		  "Array of lists of FrSummary offset positions, in bytes,"
		  " from beginning of file (size of nFrame*nSer)"
		  ) );
    }

    void FrTOCSummary::
    QuerySum( const TOCInfo& Info,
	       INT_4U FrameOffset,
	       INT_8U Position )
    {
      STRING	name;

      Info.TOCQuery( TOCInfo::IC_NAME, TOCInfo::DT_STRING_2, &name,
		     TOCInfo::IC_EOQ );

      summary_info_type& i( m_info[ name ] );
      i.resize( FrameOffset + 1 );
      i[ FrameOffset ] = Position;
    }

  } // namespace - Version_4
} // namespace - FrameCPP
